## quassel 0.10.0

=== CMakeLists.txt ===
# This is the cmake-based build system for Quassel IRC.
#
# You may pass various options to cmake:
#
# -DWANT_(CORE|QTCLIENT|MONO)=(ON|OFF)
#                        : select binaries to build
# -DWITH_OPENSSL=OFF     : Disable OpenSSL support
# -DWITH_DBUS=OFF        : Disable D-Bus support (dbus notifications)
# -DWITH_WEBKIT=OFF      : Disable WebKit support (link previews)
# -DWITH_PHONON=OFF      : Disable Phonon support (audio notifications)
# -DWITH_LIBINDICATE=OFF : Disable libindicate support (Ayatana notifications)
# -DWITH_KDE=ON          : Enable KDE4 support
# -DWITH_CRYPT=OFF       : Disable encryption support
# -DWITH_OXYGEN=(ON|OFF) : Whether to install Oxygen icons (default: yes, unless KDE > 4.3.0 is present and enabled)
# -DWITH_SYSLOG=OFF      : Disable syslog support
#
# -DEMBED_DATA=ON        : Embed all data files in icons the binary, rather than installing them separately
#
# -DQT=/path/to/qt       : Choose a Qt4 installation to use instead of the system Qt4
# -DSTATIC=ON            : Enable static building of Quassel. Use with care.
# -DDEPLOY=ON            : Mac OS X only. Use only for creating Quassel Packages!
#
# -DWITH_QT5=ON          : Enable (very) experimental support for Qt5 (see doc/README.Qt5!)
#
# NOTE: You should remove CMakeCache.txt if you plan to change any of these values!


project(QuasselIRC)

include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCXXCompilerFlag)

# For building against Qt5, we check for an even newer cmake version below!
cmake_minimum_required(VERSION 2.8.1 FATAL_ERROR)

if(COMMAND cmake_policy)
   cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

# Use our own (well, and KDE's) version of some modules
# In particular cmake's own FindQt4 and FindOpenSSL are quite buggy
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
include(QuasselMacros)

# Various options and variables that can be set on the command line
option(WANT_CORE     "Build the core (server) binary"           ON)
option(WANT_QTCLIENT "Build the Qt4 GUI client binary"          ON)
option(WANT_MONO     "Build the monolithic (all-in-one) binary" ON)

option(WITH_OPENSSL  "Enable OpenSSL support if present on the system"	ON)
option(WITH_DBUS     "Enable D-Bus support if present on the system"	ON)
option(WITH_WEBKIT   "Enable WebKit support (for link previews)"	ON)
option(WITH_PHONON   "Enable Phonon support (for audio notifications)"	ON)
option(WITH_LIBINDICATE "Enable Ayatana notification support"           ON)
option(WITH_KDE      "Enable KDE4 integration"				OFF)
option(WITH_CRYPT    "Enable encryption support if present on system"	ON)
option(WITH_SYSLOG   "Use syslog for storing log data"			ON)

# We use icon paths from KDE 4.3.x, which are partially invalid on older and possibly
# even on newer KDE versions. Do not disable this unless you are sure that your Quassel will
# run on a matching KDE version only.
set(WITH_OXYGEN AUTO CACHE STRING "Install Oxygen icons (default is \"AUTO\" to install when KDE 4.3 or later is present")

# Enable very experimental support for Qt5. Might break the compilation, or even more!
option(WITH_QT5      "Enable (very) experimental support for Qt5"       OFF)

option(STATIC        "Enable static building (might not be portable)" OFF)

if(APPLE)
  option(DEPLOY        "Mac OS X only! Adds required libs to bundle resources and create a dmg. Note: requires Qt to be built with 10.4u SDK" OFF)
  # Notification Center is only available in > 10.8, which is Darwin v12
  if(CMAKE_SYSTEM_VERSION VERSION_GREATER "11.9.9")
    option(WITH_NOTIFICATION_CENTER "Enable OS X Notification Center support" ON)
  endif(CMAKE_SYSTEM_VERSION VERSION_GREATER "11.9.9")
endif(APPLE)

# Default to embedding data in the static case
if(STATIC OR WIN32)
  set(EMBED_DEFAULT ON)
else(STATIC OR WIN32)
  set(EMBED_DEFAULT ON) # should be OFF as soon as everything works
endif(STATIC OR WIN32)

option(EMBED_DATA    "Embed all data files in the binary (rather than installing them separately)"   ${EMBED_DEFAULT})

set(QT "" CACHE STRING "Path to a Qt installation to use instead of the system Qt (e.g. for static builds)")

# Some settings imply others
if(STATIC)
  add_definitions(-DSTATIC)
  set(WITH_KDE OFF CACHE BOOL "Static building with KDE is not supported")
endif(STATIC)

if(WIN32)
  # We don't support separately installed resources yet on Win32
  set(EMBED_DATA ON)
endif(WIN32)

# For static builds, arbitrary extra libs might need to be linked
# Define a comma-separated list here
# e.g. for pgsql, we need -DLINK_EXTRA=pq;crypt
set(LINK_EXTRA "" CACHE STRING "Semicolon-separated list of libraries to be linked")
if(LINK_EXTRA)
  string(REPLACE "," ";" LINK_EXTRA ${LINK_EXTRA})
  link_libraries(${LINK_EXTRA})
endif(LINK_EXTRA)

# Build Types

if(CMAKE_CONFIGURATION_TYPES)
   set(CMAKE_CONFIGURATION_TYPES Release RelWithDebInfo Debug Debugfull Profile MinSizeRel)
   set(CMAKE_CONFIGURATION_TYPES "${CMAKE_CONFIGURATION_TYPES}" CACHE STRING
     "Reset the configurations to what we need"
     FORCE)
endif()

if(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
     "Choose the type of build, options are: None Debug Release RelWithDebInfo Debug Debugfull Profile MinSizeRel."
     FORCE)
endif()

# Qt debug flags
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS_DEBUG QT_DEBUG)
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS_DEBUGFULL QT_DEBUG)
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS_RELEASE QT_NO_DEBUG NDEBUG)
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS_RELWITHDEBINFO QT_NO_DEBUG NDEBUG)
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS_PROFILE QT_NO_DEBUG NDEBUG)
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS_MINSIZEREL QT_NO_DEBUG NDEBUG)

if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS QT_NO_DEBUG NDEBUG)
endif()

# Enable various flags on gcc
if(CMAKE_COMPILER_IS_GNUCXX)
  # Let's just hope that all gccs support these options and skip the tests...
  # -fno-strict-aliasing is needed apparently for Qt < 4.6
  set(CMAKE_CXX_FLAGS                  "${CMAKE_CXX_FLAGS} -ansi -Wall -Wextra -Wnon-virtual-dtor -fno-strict-aliasing")
#  set(CMAKE_CXX_FLAGS_RELEASE          "-O2")   # use CMake default
#  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-g -O2")  # use CMake default
  set(CMAKE_CXX_FLAGS_DEBUG             "-g -ggdb -O2 -fno-reorder-blocks -fno-schedule-insns -fno-inline")
  set(CMAKE_CXX_FLAGS_DEBUGFULL         "-g3 -ggdb -fno-inline")
  set(CMAKE_CXX_FLAGS_PROFILE           "-g3 -ggdb -fno-inline -ftest-coverage -fprofile-arcs")

  set(CMAKE_CXX_FLAGS                  "${CMAKE_CXX_FLAGS} -ansi -W -Wall -Wextra -Wnon-virtual-dtor -fno-strict-aliasing -Wundef -Wcast-align -Wpointer-arith -Wformat-security -fno-check-new -fno-common")

  check_cxx_compiler_flag(-Woverloaded-virtual CXX_W_OVERLOADED_VIRTUAL)
  if(CXX_W_OVERLOADED_VIRTUAL)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Woverloaded-virtual")
  endif()

  # Just for miniz
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-unused-function -Wno-undef -fno-strict-aliasing")
endif(CMAKE_COMPILER_IS_GNUCXX)

# ... and for Clang
if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -Wundef -Wcast-align -Wchar-subscripts -Wall -W -Wextra -Wpointer-arith -Wformat-security -Woverloaded-virtual -fno-common -Werror=return-type")
#  set(CMAKE_CXX_FLAGS_RELEASE        "-O2 -DNDEBUG -DQT_NO_DEBUG")     # Use CMake default
#  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O2 -g -DNDEBUG -DQT_NO_DEBUG")  # Use CMake default
  set(CMAKE_CXX_FLAGS_DEBUG          "-g -O2 -fno-inline")
  set(CMAKE_CXX_FLAGS_DEBUGFULL      "-g3 -fno-inline")
  set(CMAKE_CXX_FLAGS_PROFILE        "-g3 -fno-inline -ftest-coverage -fprofile-arcs")

  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-unused-function -Wno-undef -fno-strict-aliasing")
endif()

# Mac build stuff
if(APPLE AND DEPLOY)
  set(CMAKE_OSX_ARCHITECTURES "x86_64")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mmacosx-version-min=10.6")
  set(CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.6.sdk/")
  add_definitions(-DMAC_10_6_SDK)
endif(APPLE AND DEPLOY)

# Simplify checks
if(WANT_MONO OR WANT_QTCLIENT)
  set(BUILD_GUI true)
endif(WANT_MONO OR WANT_QTCLIENT)
if(WANT_MONO OR WANT_CORE)
  set(BUILD_CORE true)
endif(WANT_MONO OR WANT_CORE)


# Version checks
################

if(WITH_QT5)
  set(QT_MIN_VERSION "5.0.0")
  add_definitions(-DHAVE_QT5)

  # Qt5 needs a new enough cmake...
  cmake_minimum_required(VERSION 2.8.6 FATAL_ERROR)

  # ... for automoc
  set(CMAKE_AUTOMOC ON)
else(WITH_QT5)

  # GUI stuff needs some new features
  if(BUILD_GUI)
    set(QT_MIN_VERSION "4.6.0")
  else(BUILD_GUI)
    set(QT_MIN_VERSION "4.4.0")
  endif(BUILD_GUI)
endif(WITH_QT5)


# Dependencies
##############

if(WITH_QT5)
  find_package(Qt5Core ${QT_MIN_VERSION} REQUIRED)
  # We need QtWidgets
  set(CLIENT_QT_MODULES ${CLIENT_QT_MODULES} Widgets)

  # Setup the i18n-related variables
  find_package(Qt5LinguistTools)

else(WITH_QT5)
  # Select a Qt installation here, if you don't want to use system Qt
  if(QT)
    # FindQt4 will look for the qmake binary in $PATH, so we just prepend the Qt dir
    set(ENV{PATH} ${QT}/bin:$ENV{PATH})
  endif(QT)

  # Now that we have the correct $PATH, lets find Qt!
  find_package(Qt4 ${QT_MIN_VERSION} REQUIRED)
endif(WITH_QT5)


# Neither Qt4 nor Qt5 consider lconvert relevant, so they don't support finding it...
# Rather than shipping hacked buildsys files, let's just infer the path from lrelease
if(QT_LRELEASE_EXECUTABLE)
  get_filename_component(_lrelease_path ${QT_LRELEASE_EXECUTABLE} PATH)
  if(WITH_QT5)
    find_program(QT_LCONVERT_EXECUTABLE NAMES lconvert-qt5 lconvert PATHS ${_lrelease_path} NO_DEFAULT_PATH NO_CMAKE_FIND_ROOT_PATH)
  else(WITH_QT5)
    find_program(QT_LCONVERT_EXECUTABLE NAMES lconvert-qt4 lconvert PATHS ${_lrelease_path} NO_DEFAULT_PATH NO_CMAKE_FIND_ROOT_PATH)
  endif(WITH_QT5)
endif(QT_LRELEASE_EXECUTABLE)


# zlib for compression, however we can always fall back to miniz
find_package(ZLIB)
if(ZLIB_FOUND)
  message(STATUS "Using system zlib for compression")
  add_definitions(-DHAVE_ZLIB)
  include_directories(${ZLIB_INCLUDE_DIRS})
  set(COMMON_LIBRARIES ${COMMON_LIBRARIES} ${ZLIB_LIBRARIES})
else()
  message(STATUS "zlib NOT found, using bundled miniz for compression")
  if(${CMAKE_SIZEOF_VOID_P} EQUAL 4)
    message(STATUS "WARNING: This may be slow on 32 bit systems!")
  endif()
endif()


# Execinfo is needed for generating backtraces
find_package(ExecInfo)
if(EXECINFO_FOUND)
  add_definitions(-DHAVE_EXECINFO)
  include_directories(${EXECINFO_INCLUDES})
  link_libraries(${EXECINFO_LIBRARIES})
endif(EXECINFO_FOUND)


# PkgConfig isn't strictly required.
# However, some optional deps might not be found if it's not present, so warn!
find_package(PkgConfig)
if(NOT PKG_CONFIG_FOUND)
  message(STATUS "WARNING: PkgConfig not available! Some dependencies for optional features might not be found.")
  message(STATUS "         Affected features might include encryption support, DBus menus and Ayatana notifications.")
endif(NOT PKG_CONFIG_FOUND)


# Setup OpenSSL
# We don't link to or include OpenSSL ourselves, but use exclusively the Qt API.
# Thus, we simply check if OpenSSL support is present in Qt's config and enable our
# own SSL stuff in this case. Qt should care for adding what it needs itself.
if(WITH_OPENSSL)
  if(QT_QCONFIG MATCHES "openssl")
    message(STATUS "Found OpenSSL support in Qt, enabling SSL")
    add_definitions(-DHAVE_SSL)
    set(HAVE_SSL true)
  else(QT_QCONFIG MATCHES "openssl")
    message(STATUS "No OpenSSL support found in Qt, disabling SSL")
    add_definitions(-DQT_NO_OPENSSL)
  endif(QT_QCONFIG MATCHES "openssl")
else(WITH_OPENSSL)
  message(STATUS "Not enabling OpenSSL support")
endif(WITH_OPENSSL)


# Check for GUI specific stuff
if(BUILD_GUI)

=== pics/CMakeLists.txt ===
# pics/ contains non-themed icons and other graphical resources

if(WIN32)
  if(MINGW)
    find_program(WINDRES_EXECUTABLE NAMES windres)
    if(WINDRES_EXECUTABLE)
      exec_program(windres
              ARGS "-i ${CMAKE_CURRENT_SOURCE_DIR}/win32.rc"
                   "-o ${CMAKE_CURRENT_BINARY_DIR}/win32.o"
                   "--include-dir=${CMAKE_CURRENT_SOURCE_DIR}")
      set(COMMON_DEPS ${COMMON_DEPS} ${CMAKE_CURRENT_BINARY_DIR}/win32.o PARENT_SCOPE)
    endif(WINDRES_EXECUTABLE)
  else(MINGW)
    set(COMMON_DEPS ${COMMON_DEPS} ../pics/win32.rc PARENT_SCOPE)
  endif(MINGW)
endif(WIN32)

if(WANT_MONO OR WANT_QTCLIENT)
  if(EMBED_DATA)
    set(CLIENT_RCS ${CLIENT_RCS} ../pics/pics.qrc PARENT_SCOPE)
  else(EMBED_DATA)
    # We don't find them yet externally, so disable installation
    set(CLIENT_RCS ${CLIENT_RCS} ../pics/pics.qrc PARENT_SCOPE)
    # install(FILES qt-logo.png
    #               quassel-large.png
    #         DESTINATION ${DATA_INSTALL_DIR}/quassel/pics)
  endif(EMBED_DATA)
endif(WANT_MONO OR WANT_QTCLIENT)

=== po/CMakeLists.txt ===
# Generate and add translations
# The LINGUAS variable can be used to limit that set

if(QT_LCONVERT_EXECUTABLE)
  # get environment variable for translations
  set(LINGUAS "$ENV{LINGUAS}")
  string(REGEX REPLACE "[ \t]+" \; output "${LINGUAS}")
  # Find more languages
  # We support xx.po and xx_YY.po, and additionally translations for qt using qt_xx.po or qt_xx_YY.po
  file(GLOB avail_pofiles *.po)
  foreach(PO_FILE ${avail_pofiles})
    get_filename_component(basename ${PO_FILE} NAME_WE)
    # CMake can't use MATCH to get the second catch...
    string(REGEX REPLACE "(qt_)?([a-zA-Z]+)(_.+)?$" "\\2" lang ${basename})

    # test if we want this language
    set(flg 1)
    if(LINGUAS)
      string(REGEX MATCH "${lang}" flg ${LINGUAS})
    endif(LINGUAS)
    if(flg)
      generate_ts(QM ${basename})
      generate_qm(QM ${basename})
      list(APPEND qm_files ${QM})
      list(APPEND gen_linguas ${lang})
    endif(flg)
  endforeach(PO_FILE ${avail_pofiles})
  if(gen_linguas)
    list(REMOVE_DUPLICATES gen_linguas)
  endif(gen_linguas)
  message(STATUS "Including languages: ${gen_linguas}")
else(QT_LCONVERT_EXECUTABLE)
  message(STATUS "WARNING: lconvert not found, you won't have translations!")
endif(QT_LCONVERT_EXECUTABLE)

# For a static or win32 build, we need to include Qt translations if available
if(QT_TRANSLATIONS_DIR)
  if(STATIC OR WIN32)
    foreach(LANG ${gen_linguas})
      file(GLOB lang_files ${QT_TRANSLATIONS_DIR}/qt_${LANG}*.qm)
      foreach(absfile ${lang_files})
        get_filename_component(filename ${absfile} NAME)
        message(STATUS "Importing ${filename}")
        configure_file(${absfile} ${CMAKE_CURRENT_BINARY_DIR}/${filename} COPYONLY)
        list(APPEND qm_files ${CMAKE_CURRENT_BINARY_DIR}/${filename})
      endforeach(absfile ${lang_files})
    endforeach(LANG ${gen_linguas})
  endif(STATIC OR WIN32)
endif(QT_TRANSLATIONS_DIR)

# Write resource file
set(resfile ${CMAKE_CURRENT_BINARY_DIR}/i18n.qrc)
file(WRITE ${resfile} "<!DOCTYPE RCC><RCC version=\"1.0\">\n"
                      "<qresource prefix=\"/i18n\">\n")
foreach(file ${qm_files})
  get_filename_component(file ${file} NAME)
  file(APPEND ${resfile} "    <file>${file}</file>\n")
endforeach(file ${qm_files})
file(APPEND ${resfile} "</qresource>\n</RCC>\n")

#add_custom_command(OUTPUT ${resfile} DEPENDS ${qm_files})
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${qm_files};i18n.qrc")

if(EMBED_DATA)
  set(COMMON_RCS ${COMMON_RCS} ${resfile} PARENT_SCOPE)
else(EMBED_DATA)
  install(FILES ${qm_files} DESTINATION ${DATA_INSTALL_DIR}/quassel/translations)
endif(EMBED_DATA)

add_custom_target(po DEPENDS ${qm_files})

=== src/CMakeLists.txt ===
# Builds the three main targets

add_subdirectory(common)
include_directories(BEFORE common)
if(BUILD_CORE)
  add_subdirectory(core)
  include_directories(BEFORE core)
endif(BUILD_CORE)
if(BUILD_GUI)
  add_subdirectory(client)
  add_subdirectory(uisupport)
  add_subdirectory(qtui)
  include_directories(BEFORE client)
  include_directories(BEFORE uisupport)
  include_directories(BEFORE qtui)

  if(STATIC)
    link_directories(${QT_PLUGINS_DIR}/imageformats)
    set(CLIENT_LIBRARIES ${CLIENT_LIBRARIES} qjpeg qgif)
  endif(STATIC)
endif(BUILD_GUI)

include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR}) # for version.gen

# Add resources. Can't be done in other subdirs apparently.
# Note that these variables need to contain paths relative to src/ (this dir)
if(WITH_QT5)
  qt5_add_resources(CLIENT_DEPS ${CLIENT_RCS})
  qt5_add_resources(CORE_DEPS ${CORE_RCS})
  qt5_add_resources(COMMON_DEPS ${COMMON_RCS})
else(WITH_QT5)
  qt4_add_resources(CLIENT_DEPS ${CLIENT_RCS})
  qt4_add_resources(CORE_DEPS ${CORE_RCS})
  qt4_add_resources(COMMON_DEPS ${COMMON_RCS})
endif(WITH_QT5)

if(WANT_CORE)
  setup_qt_variables(Network Script Sql ${CORE_QT_MODULES})
  include_directories(${QUASSEL_QT_INCLUDES})
  add_executable(quasselcore common/main.cpp ${COMMON_DEPS} ${CORE_DEPS})
  add_dependencies(quasselcore po genversion_run)
  set_target_properties(quasselcore PROPERTIES
                                    COMPILE_FLAGS "-DBUILD_CORE ${QUASSEL_QT_COMPILEFLAGS}"
                                    OUTPUT_NAME ../quasselcore)
  target_link_libraries(quasselcore mod_core mod_common ${COMMON_LIBRARIES}
                                    ${QUASSEL_QT_LIBRARIES} ${QUASSEL_SSL_LIBRARIES})
  install(TARGETS quasselcore RUNTIME DESTINATION ${BIN_INSTALL_DIR})
endif(WANT_CORE)

if(WANT_QTCLIENT)
  setup_qt_variables(Gui Network ${CLIENT_QT_MODULES})
  include_directories(${QUASSEL_QT_INCLUDES})
  add_executable(quasselclient WIN32 common/main.cpp ${COMMON_DEPS} ${CLIENT_DEPS})
  add_dependencies(quasselclient po genversion_run)
  set_target_properties(quasselclient PROPERTIES
                                      COMPILE_FLAGS "-DBUILD_QTUI ${QUASSEL_QT_COMPILEFLAGS} ${CLIENT_COMPILE_FLAGS}"
                                      OUTPUT_NAME ../quasselclient)
  target_link_libraries(quasselclient ${LINK_KDE} mod_qtui mod_uisupport mod_client mod_common ${COMMON_LIBRARIES}
                                      ${QUASSEL_QT_LIBRARIES} ${QUASSEL_SSL_LIBRARIES} ${CLIENT_LIBRARIES})
  install(TARGETS quasselclient RUNTIME DESTINATION ${BIN_INSTALL_DIR})
endif(WANT_QTCLIENT)

if(WANT_MONO)
  setup_qt_variables(Gui Network Script Sql ${CLIENT_QT_MODULES} ${CORE_QT_MODULES})
  include_directories(${QUASSEL_QT_INCLUDES})
  if(NOT WITH_QT5)
    qt4_wrap_cpp(MOC qtui/monoapplication.h)
  endif(NOT WITH_QT5)
  add_executable(quassel WIN32 common/main.cpp qtui/monoapplication.cpp ${MOC} ${COMMON_DEPS} ${CLIENT_DEPS} ${CORE_DEPS})
  add_dependencies(quassel po genversion_run)
  set_target_properties(quassel PROPERTIES
                                COMPILE_FLAGS "-DBUILD_MONO ${QUASSEL_QT_COMPILEFLAGS} ${CLIENT_COMPILE_FLAGS}"
                                OUTPUT_NAME ../quassel)
  target_link_libraries(quassel mod_qtui mod_uisupport mod_client mod_core mod_common ${COMMON_LIBRARIES}
                                ${QUASSEL_QT_LIBRARIES} ${QUASSEL_SSL_LIBRARIES} ${CLIENT_LIBRARIES})
  install(TARGETS quassel RUNTIME DESTINATION ${BIN_INSTALL_DIR})
endif(WANT_MONO)

# Build bundles for MacOSX
if(APPLE)
  add_custom_command(TARGET quasselclient POST_BUILD
                     COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makebundle.py
                             ${CMAKE_SOURCE_DIR} "Quassel Client" ../quasselclient)
  add_custom_command(TARGET quassel POST_BUILD
                     COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makebundle.py
                             ${CMAKE_SOURCE_DIR} "Quassel" ../quassel)
  if(DEPLOY)
    add_custom_command(TARGET quasselclient POST_BUILD
                       COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makePackage.sh Client ..)
    add_custom_command(TARGET quasselcore POST_BUILD
                       COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makePackage.sh Core ..)
  endif(DEPLOY)
endif(APPLE)

=== src/client/CMakeLists.txt ===
# Builds the client module

# In Qt4, we still have some minor deps to QtUi: QItemSelectionModel, QSortFilterProxyModel
# Still in Qt5: QAbstractItemView in BufferModel

set(_modules )

if(WITH_QT5)
  list(APPEND _modules Widgets)
endif(WITH_QT5)

if(HAVE_DBUS)
  list(APPEND _modules DBus)
endif(HAVE_DBUS)

setup_qt_variables(Gui Network ${_modules})

set(SOURCES
    abstractmessageprocessor.cpp
    abstractui.cpp
    backlogrequester.cpp
    buffermodel.cpp
    buffersettings.cpp
    bufferviewoverlay.cpp
    client.cpp
    clientaliasmanager.cpp
    clientauthhandler.cpp
    clientbacklogmanager.cpp
    clientbufferviewconfig.cpp
    clientbufferviewmanager.cpp
    clientcoreinfo.cpp
    clientidentity.cpp
    clientignorelistmanager.cpp
    clientirclisthelper.cpp
    clientsettings.cpp
    clientuserinputhandler.cpp
    coreaccount.cpp
    coreaccountmodel.cpp
    coreconnection.cpp
    execwrapper.cpp
    irclistmodel.cpp
    messagefilter.cpp
    messagemodel.cpp
    networkmodel.cpp
    selectionmodelsynchronizer.cpp
    treemodel.cpp)

set(MOC_HDRS
    abstractmessageprocessor.h
    abstractui.h
    buffermodel.h
    bufferviewoverlay.h
    client.h
    clientaliasmanager.h
    clientauthhandler.h
    clientbacklogmanager.h
    clientbufferviewconfig.h
    clientbufferviewmanager.h
    clientcoreinfo.h
    clientidentity.h
    clientignorelistmanager.h
    clientirclisthelper.h
    clientuserinputhandler.h
    coreaccountmodel.h
    coreconnection.h
    execwrapper.h
    irclistmodel.h
    messagefilter.h
    messagemodel.h
    networkmodel.h
    selectionmodelsynchronizer.h
    treemodel.h)

set(HEADERS
    backlogsettings.h
    backlogrequester.h
    buffersettings.h
    clientsettings.h
    coreaccount.h
   )

include_directories(${CMAKE_SOURCE_DIR}/src/common ${QUASSEL_QT_INCLUDES})

if(NOT WITH_QT5)
  qt4_wrap_cpp(MOC ${MOC_HDRS})
endif(NOT WITH_QT5)

add_library(mod_client STATIC ${SOURCES} ${MOC} ${HEADERS})
add_dependencies(mod_client mod_common)

set_target_properties(mod_client PROPERTIES COMPILE_FLAGS "${QUASSEL_QT_COMPILEFLAGS}")

=== src/common/CMakeLists.txt ===
# Builds the common module

setup_qt_variables(Core Network)

set(SOURCES
    aliasmanager.cpp
    authhandler.cpp
    backlogmanager.cpp
    basichandler.cpp
    bufferinfo.cpp
    buffersyncer.cpp
    bufferviewconfig.cpp
    bufferviewmanager.cpp
    cliparser.cpp
    compressor.cpp
    coreinfo.cpp
    ctcpevent.cpp
    event.cpp
    eventmanager.cpp
    identity.cpp
    ignorelistmanager.cpp
    internalpeer.cpp
    ircchannel.cpp
    ircevent.cpp
    irclisthelper.cpp
    ircuser.cpp
    logger.cpp
    message.cpp
    messageevent.cpp
    network.cpp
    networkconfig.cpp
    networkevent.cpp
    peer.cpp
    peerfactory.cpp
    quassel.cpp
    remotepeer.cpp
    settings.cpp
    signalproxy.cpp
    syncableobject.cpp
    util.cpp

    protocols/datastream/datastreampeer.cpp
    protocols/legacy/legacypeer.cpp
)

set(MOC_HDRS
    aliasmanager.h
    authhandler.h
    backlogmanager.h
    basichandler.h
    buffersyncer.h
    bufferviewconfig.h
    bufferviewmanager.h
    compressor.h
    coreinfo.h
    eventmanager.h
    identity.h
    ignorelistmanager.h
    internalpeer.h
    ircchannel.h
    irclisthelper.h
    ircuser.h
    network.h
    networkconfig.h
    peer.h
    remotepeer.h
    settings.h
    signalproxy.h
    syncableobject.h

    protocols/datastream/datastreampeer.h
    protocols/legacy/legacypeer.h
)

set(HEADERS ${MOC_HDRS}
    abstractcliparser.h
    bufferinfo.h
    cliparser.h
    ctcpevent.h
    event.h
    ircevent.h
    messageevent.h
    networkevent.h
    logger.h
    message.h
    peerfactory.h
    protocol.h
    types.h
    util.h)

if (HAVE_QCA2)
    set(SOURCES ${SOURCES} keyevent.cpp)
    set(HEADERS ${HEADERS} keyevent.h)
endif(HAVE_QCA2)

if(NOT HAVE_ZLIB)
    set(SOURCES ${SOURCES} ../../3rdparty/miniz/miniz.c)
endif(NOT HAVE_ZLIB)

if(APPLE)
  set(SOURCES ${SOURCES} mac_utils.cpp)
  set(HEADERS ${HEADERS} mac_utils.h)
endif(APPLE)

if(CMAKE_HOST_WIN32)
    set(SOURCES ${SOURCES} logbacktrace_win.cpp)
endif(CMAKE_HOST_WIN32)
if(CMAKE_HOST_UNIX)
    set(SOURCES ${SOURCES} logbacktrace_unix.cpp)
endif(CMAKE_HOST_UNIX)

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${QUASSEL_QT_INCLUDES})  # for version.inc and version.gen

if(NOT WITH_QT5)
  qt4_wrap_cpp(MOC ${MOC_HDRS})
endif(NOT WITH_QT5)

set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES version.gen)

add_library(mod_common STATIC ${SOURCES} ${HEADERS} ${MOC})
set_target_properties(mod_common PROPERTIES COMPILE_FLAGS "${QUASSEL_QT_COMPILEFLAGS}")

if(APPLE)
  target_link_libraries(mod_common "-framework CoreServices" "-framework CoreFoundation")
endif(APPLE)

target_link_libraries(mod_common ${CMAKE_DL_LIBS})

=== src/core/CMakeLists.txt ===
# Builds the core module

setup_qt_variables(Network Sql Script)

set(SOURCES
    abstractsqlstorage.cpp
    core.cpp
    corealiasmanager.cpp
    coreapplication.cpp
    coreauthhandler.cpp
    corebacklogmanager.cpp
    corebasichandler.cpp
    corebuffersyncer.cpp
    corebufferviewconfig.cpp
    corebufferviewmanager.cpp
    corecoreinfo.cpp
    coreidentity.cpp
    coreignorelistmanager.cpp
    coreircchannel.cpp
    coreirclisthelper.cpp
    coreircuser.cpp
    corenetwork.cpp
    corenetworkconfig.cpp
    coresession.cpp
    coresessioneventprocessor.cpp
    coresettings.cpp
    coreuserinputhandler.cpp
    coreusersettings.cpp
    ctcpparser.cpp
    eventstringifier.cpp
    ircparser.cpp
    netsplit.cpp
    oidentdconfiggenerator.cpp
    postgresqlstorage.cpp
    sessionthread.cpp
    sqlitestorage.cpp
    storage.cpp)

set(MOC_HDRS
    abstractsqlstorage.h
    core.h
    corealiasmanager.h
    coreapplication.h
    coreauthhandler.h
    corebacklogmanager.h
    corebasichandler.h
    corebuffersyncer.h
    corebufferviewconfig.h
    corebufferviewmanager.h
    corecoreinfo.h
    coreeventmanager.h
    coreidentity.h
    coreignorelistmanager.h
    coreircchannel.h
    coreirclisthelper.h
    coreircuser.h
    corenetwork.h
    corenetworkconfig.h
    coresession.h
    coresessioneventprocessor.h
    coreuserinputhandler.h
    ctcpparser.h
    eventstringifier.h
    ircparser.h
    netsplit.h
    oidentdconfiggenerator.h
    postgresqlstorage.h
    sqlitestorage.h
    storage.h
    sessionthread.h)

set(HEADERS
    coresettings.h
    coreusersettings.h)

if(HAVE_SSL)
  set(SOURCES ${SOURCES} sslserver.cpp)
  set(MOC_HDRS ${MOC_HDRS} sslserver.h)
  include_directories(${OPENSSL_INCLUDE_DIR})
endif(HAVE_SSL)

if(HAVE_QCA2)
  set(SOURCES ${SOURCES} cipher.cpp)
  set(HEADERS ${HEADERS} cipher.h)
  include_directories(${QCA2_INCLUDE_DIR})
endif(HAVE_QCA2)

include_directories(${CMAKE_SOURCE_DIR}/src/common ${QUASSEL_QT_INCLUDES})

if(NOT WITH_QT5)
  qt4_wrap_cpp(MOC ${MOC_HDRS})
endif(NOT WITH_QT5)

set(CORE_RCS ${CORE_RCS} core/sql.qrc PARENT_SCOPE)

add_library(mod_core STATIC ${SOURCES} ${MOC} ${HEADERS})
add_dependencies(mod_core mod_common)
set_target_properties(mod_core PROPERTIES COMPILE_FLAGS "${QUASSEL_QT_COMPILEFLAGS}")

if(HAVE_QCA2)
  target_link_libraries(mod_core ${QCA2_LIBRARIES})
endif(HAVE_QCA2)

=== src/qtui/CMakeLists.txt ===
# Builds the qtui module

set(_modules )

if(WITH_QT5)
  list(APPEND _modules Widgets)
endif(WITH_QT5)

if(HAVE_DBUS)
  list(APPEND _modules DBus)
endif(HAVE_DBUS)

if(HAVE_WEBKIT)
  list(APPEND _modules Webkit XmlPatterns)
endif(HAVE_WEBKIT)

setup_qt_variables(Gui Network ${_modules})

set(SOURCES
    aboutdlg.cpp
    awaylogfilter.cpp
    awaylogview.cpp
    bufferwidget.cpp
    channellistdlg.cpp
    chatitem.cpp
    chatline.cpp
    chatlinemodel.cpp
    chatlinemodelitem.cpp
    chatmonitorfilter.cpp
    chatmonitorview.cpp
    chatscene.cpp
    chatview.cpp
    chatviewsearchbar.cpp
    chatviewsearchcontroller.cpp
    chatviewsettings.cpp
    columnhandleitem.cpp
    coreconfigwizard.cpp
    coreconnectdlg.cpp
    coreconnectionstatuswidget.cpp
    coreinfodlg.cpp
    debugbufferviewoverlay.cpp
    debugconsole.cpp
    debuglogwidget.cpp
    debugmessagemodelfilter.cpp
    inputwidget.cpp
    ircconnectionwizard.cpp
    legacysystemtray.cpp
    mainpage.cpp
    mainwin.cpp
    markerlineitem.cpp
    msgprocessorstatuswidget.cpp
    nicklistwidget.cpp
    qtui.cpp
    qtuiapplication.cpp
    qtuimessageprocessor.cpp
    qtuisettings.cpp
    qtuistyle.cpp
    settingsdlg.cpp
    settingspagedlg.cpp
    simplenetworkeditor.cpp
    systemtray.cpp
    systraynotificationbackend.cpp
    taskbarnotificationbackend.cpp
    titlesetter.cpp
    topicwidget.cpp
    verticaldock.cpp
    webpreviewitem.cpp)

set(MOC_HDRS
    aboutdlg.h
    awaylogfilter.h
    awaylogview.h
    bufferwidget.h
    channellistdlg.h
    chatitem.h
    chatlinemodel.h
    chatmonitorfilter.h
    chatmonitorview.h
    chatscene.h
    chatview.h
    chatviewsearchbar.h
    chatviewsearchcontroller.h
    columnhandleitem.h
    coreconfigwizard.h
    coreconnectdlg.h
    coreconnectionstatuswidget.h
    coreinfodlg.h
    debugbufferviewoverlay.h
    debugconsole.h
    debuglogwidget.h
    debugmessagemodelfilter.h
    inputwidget.h
    ircconnectionwizard.h
    legacysystemtray.h
    mainpage.h
    mainwin.h
    markerlineitem.h
    msgprocessorstatuswidget.h
    nicklistwidget.h
    qtui.h
    qtuiapplication.h
    qtuimessageprocessor.h
    qtuistyle.h
    settingsdlg.h
    settingspagedlg.h
    simplenetworkeditor.h
    systemtray.h
    systraynotificationbackend.h
    taskbarnotificationbackend.h
    titlesetter.h
    topicwidget.h
    verticaldock.h)

set(HEADERS
    chatline.h
    chatlinemodelitem.h
    chatviewsettings.h
    qtuisettings.h
    webpreviewitem.h)

set(FORMS
    aboutdlg.ui
    bufferviewwidget.ui
    bufferwidget.ui
    channellistdlg.ui
    chatviewsearchbar.ui
    coreconfigwizardintropage.ui
    coreconfigwizardadminuserpage.ui
    coreconfigwizardstorageselectionpage.ui
    coreconfigwizardsyncpage.ui
    coreconnectauthdlg.ui
    coreconnectionstatuswidget.ui
    coreinfodlg.ui
    debugbufferviewoverlay.ui
    debugconsole.ui
    debuglogwidget.ui
    inputwidget.ui
    msgprocessorstatuswidget.ui
    nicklistwidget.ui
    settingsdlg.ui
    settingspagedlg.ui
    simplenetworkeditor.ui
    topicwidget.ui)

if(HAVE_KDE)
  set(SOURCES ${SOURCES} knotificationbackend.cpp)
  set(MOC_HDRS ${MOC_HDRS} knotificationbackend.h)
else(HAVE_KDE)
  if(HAVE_SNORENOTIFY)
    set(SOURCES ${SOURCES} snorenotificationbackend.cpp)
    set(MOC_HDRS ${MOC_HDRS} snorenotificationbackend.h)
    set(FORMS ${FORMS} snorentificationconfigwidget.ui)
  endif(HAVE_SNORENOTIFY)
  if(HAVE_PHONON)
    set(SOURCES ${SOURCES} phononnotificationbackend.cpp)
    set(MOC_HDRS ${MOC_HDRS} phononnotificationbackend.h)
    set(FORMS ${FORMS} phononnotificationconfigwidget.ui)
    include_directories(${PHONON_INCLUDES})
  endif(HAVE_PHONON)
endif(HAVE_KDE)

if(HAVE_DBUS)
  set(SOURCES ${SOURCES} statusnotifieritem.cpp statusnotifieritemdbus.cpp dockmanagernotificationbackend.cpp)
  set(MOC_HDRS ${MOC_HDRS} statusnotifieritem.h statusnotifieritemdbus.h dockmanagernotificationbackend.h)
  set(FORMS ${FORMS})
  if(WITH_QT5)
    qt5_add_dbus_interface(DBUS ../../interfaces/org.kde.StatusNotifierWatcher.xml statusnotifierwatcher)
    qt5_add_dbus_interface(DBUS ../../interfaces/org.freedesktop.Notifications.xml notificationsclient)
    qt5_add_dbus_adaptor(DBUS ../../interfaces/org.kde.StatusNotifierItem.xml statusnotifieritemdbus.h StatusNotifierItemDBus)
  else(WITH_QT5)
    qt4_add_dbus_interface(DBUS ../../interfaces/org.kde.StatusNotifierWatcher.xml statusnotifierwatcher)
    qt4_add_dbus_interface(DBUS ../../interfaces/org.freedesktop.Notifications.xml notificationsclient)
    qt4_add_dbus_adaptor(DBUS ../../interfaces/org.kde.StatusNotifierItem.xml statusnotifieritemdbus.h StatusNotifierItemDBus)
  endif(WITH_QT5)
endif(HAVE_DBUS)

if(HAVE_SSL)
  set(SOURCES ${SOURCES} sslinfodlg.cpp)
  set(MOC_HDRS ${MOC_HDRS} sslinfodlg.h)
  set(FORMS ${FORMS} sslinfodlg.ui)
endif(HAVE_SSL)

if(INDICATEQT_FOUND)
  set(SOURCES ${SOURCES} indicatornotificationbackend.cpp)
  set(MOC_HDRS ${MOC_HDRS} indicatornotificationbackend.h)
  set(FORMS ${FORMS} indicatornotificationconfigwidget.ui)
  include_directories(${INDICATEQT_INCLUDE_DIRS})
endif(INDICATEQT_FOUND)

if(HAVE_NOTIFICATION_CENTER)
  set(SOURCES ${SOURCES} osxnotificationbackend.mm)
  set(MOC_HDRS ${MOC_HDRS} osxnotificationbackend.h)
endif()

foreach(FORM ${FORMS})
  set(FORMPATH ${FORMPATH} ui/${FORM})
endforeach(FORM ${FORMS})

# handle settingspages
include(settingspages/settingspages.cmake)
foreach(SP ${SETTINGSPAGES})
  set(SPSRC ${SPSRC} settingspages/${SP}settingspage.cpp)
  set(SPHDR ${SPHDR} settingspages/${SP}settingspage.h)
  set(SPFRM ${SPFRM} settingspages/${SP}settingspage.ui)
endforeach(SP ${SETTINGSPAGES})
foreach(SRC ${SP_SOURCES})
  set(SPSRC ${SPSRC} settingspages/${SRC})
endforeach(SRC ${SP_SOURCES})
foreach(HDR ${SP_HEADERS})
  set(SPHDR ${SPHDR} settingspages/${HDR})
endforeach(HDR ${SP_HEADERS})
foreach(FRM ${SP_FORMS})
  set(SPFRM ${SPFRM} settingspages/${FRM})
endforeach(FRM ${SP_FORMS})

include_directories(${CMAKE_SOURCE_DIR}/src/common
                    ${CMAKE_SOURCE_DIR}/src/client
                    ${CMAKE_SOURCE_DIR}/src/qtui
                    ${CMAKE_SOURCE_DIR}/src/qtui/settingspages
                    ${CMAKE_SOURCE_DIR}/src/uisupport
                    ${CMAKE_CURRENT_BINARY_DIR}
                    ${QUASSEL_QT_INCLUDES})

if(WITH_QT5)
  qt5_wrap_ui(UI ${FORMPATH} ${SPFRM})
else(WITH_QT5)
  qt4_wrap_cpp(MOC ${MOC_HDRS} ${SPHDR})
  qt4_wrap_ui(UI ${FORMPATH} ${SPFRM})
endif(WITH_QT5)

add_library(mod_qtui STATIC ${SOURCES} ${SPSRC} ${MOC} ${DBUS} ${UI} ${HEADERS})
add_dependencies(mod_qtui mod_common mod_client mod_uisupport)
set_target_properties(mod_qtui PROPERTIES COMPILE_FLAGS "${QUASSEL_QT_COMPILEFLAGS}")

=== src/uisupport/CMakeLists.txt ===
# Builds the uisupport module

if(WITH_QT5)
  setup_qt_variables(Widgets Network)
else(WITH_QT5)
  setup_qt_variables(Gui Network)
endif(WITH_QT5)

set(SOURCES
    abstractbuffercontainer.cpp
    abstractitemview.cpp
    abstractnotificationbackend.cpp
    action.cpp
    actioncollection.cpp
    bufferhotlistfilter.cpp
    bufferview.cpp
    bufferviewfilter.cpp
    bufferviewoverlayfilter.cpp
    clearablelineedit.cpp
    clickable.cpp
    clickablelabel.cpp
    colorbutton.cpp
    contextmenuactionprovider.cpp
    flatproxymodel.cpp
    fontselector.cpp
    graphicalui.cpp
    icon.cpp
    iconloader.cpp
    multilineedit.cpp
    networkmodelcontroller.cpp
    nickview.cpp
    nickviewfilter.cpp
    qssparser.cpp
    resizingstackedwidget.cpp
    settingspage.cpp
    styledlabel.cpp
    tabcompleter.cpp
    toolbaractionprovider.cpp
    uisettings.cpp
    uistyle.cpp
   )

set(MOC_HDRS
    abstractbuffercontainer.h
    abstractitemview.h
    abstractnotificationbackend.h
    action.h
    actioncollection.h
    bufferhotlistfilter.h
    bufferview.h
    bufferviewfilter.h
    bufferviewoverlayfilter.h
    clearablelineedit.h
    clickablelabel.h
    colorbutton.h
    contextmenuactionprovider.h
    flatproxymodel.h
    fontselector.h
    graphicalui.h
    iconloader.h
    multilineedit.h
    networkmodelcontroller.h
    nickview.h
    nickviewfilter.h
    resizingstackedwidget.h
    settingspage.h
    styledlabel.h
    tabcompleter.h
    toolbaractionprovider.h
    uistyle.h
   )

set(HEADERS
    clickable.h
    icon.h
    qssparser.h
    uisettings.h
   )

if(HAVE_KDE)
    set(SOURCES ${SOURCES} kcmdlinewrapper.cpp)
    set(HEADERS ${HEADERS} kcmdlinewrapper.h)
endif(HAVE_KDE)

include_directories(${CMAKE_SOURCE_DIR}/src/common
                    ${CMAKE_SOURCE_DIR}/src/client
                    ${QUASSEL_QT_INCLUDES})

if(HAVE_QCA2)
  include_directories(${QCA2_INCLUDE_DIR})
endif(HAVE_QCA2)

if(NOT WITH_QT5)
  qt4_wrap_cpp(MOC ${MOC_HDRS})
endif(NOT WITH_QT5)

add_library(mod_uisupport STATIC ${SOURCES} ${MOC} ${HEADERS})
add_dependencies(mod_uisupport mod_common mod_client)
set_target_properties(mod_uisupport PROPERTIES COMPILE_FLAGS "${QUASSEL_QT_COMPILEFLAGS}")

=== debian/changelog ===
quassel (1:0.10.0-2.3+deb8u4) jessie-security; urgency=high

  * Backport upstream commit to implement a custom deserializer.
    Fixes possible remote code execution. (Closes: #896914)
  * Backport upstream commit to reject client logins before the core is
    configured. Fixes a DoS vulnerability. (Closes: #896915)

 -- Felix Geyer <fgeyer@debian.org>  Sat, 28 Apr 2018 11:54:10 +0200

quassel (1:0.10.0-2.3+deb8u3) jessie; urgency=medium

  * Non-maintainer upload.
  * Fix CVE-2016-4414: remote DoS in quassel core with invalid handshake data.
    (Closes: #826402)
    - Add debian/patches/CVE-2016-4414.patch, cherry-picked from upstream.

 -- Pierre Schweitzer <pierre@reactos.org>  Sun, 05 Jun 2016 12:41:35 +0200

quassel (1:0.10.0-2.3+deb8u2) jessie; urgency=high

  * Non-maintainer upload.
  * Fix CVE-2015-8547: remote DoS in quassel core, using /op * command.
    (Closes: #807801)
    - Add debian/patches/CVE-2015-8547.patch, cherry-picked from upstream.

 -- Pierre Schweitzer <pierre@reactos.org>  Sun, 13 Dec 2015 11:04:05 +0100

quassel (1:0.10.0-2.3+deb8u1) jessie-security; urgency=high

  * Fix CVE-2015-3427: SQL injection vulnerability in PostgreSQL backend.
    (Closes: #783926)
    - Add debian/patches/CVE-2015-3427.patch, cherry-picked from upstream.
    - The original issue was CVE-2013-4422 which had an incomplete fix.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 10 May 2015 16:41:30 +0200

quassel (1:0.10.0-2.3) unstable; urgency=high

  * Non-maintainer upload with maintainer's permission.
  * Improve the message-splitting algorithm for PRIVMSG and CTCP.  Original
    patch from Michael Marley, backported by Steinar H. Gunderson.  Fixes
    CVE-2015-2778 and CVE-2015-2779.  (Closes: #781024)

 -- Olly Betts <olly@survex.com>  Wed, 01 Apr 2015 11:41:28 +1300

quassel (1:0.10.0-2.2) unstable; urgency=high

  * Non-maintainer upload.
  * Increment Debian revision and epoch to re-upload 0.10.0-2.1 to
    unstable containing the fix for #766962 / CVE-2014-8483:
    out-of-bounds read in ECB Blowfish decryption.

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 08 Nov 2014 14:14:56 +0100

quassel (0.10.0-2.1) unstable; urgency=high

  * Non-maintainer upload.
  * Add CVE-2014-8483.patch patch.
    CVE-2014-8483: out-of-bounds read in ECB Blowfish decryption.
    (Closes: #766962)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 02 Nov 2014 19:10:58 +0100

quassel (0.10.0-2) unstable; urgency=low

  * Fixing security issue where quassel core certificate is 
    readable by all local users
    - Change permissions of /var/lib/quassel/quasselCert.pem
    - Add debian/NEWS to notify the admin to change the certificate

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Fri, 04 Jul 2014 17:15:10 +0200

quassel (0.10.0-1) unstable; urgency=low

  * New upstream release
  * Debian policy to 3.9.5
  * Don't create 1024 bit key (Closes: #732728)
  * Start quaselcore after databases (Closes: #701943)

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Fri, 09 May 2014 17:42:19 +0200

quassel (0.9.2-1) unstable; urgency=low

  * New upstream release
  * Increase debhelper compat to 9 - supporting hardening now

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Tue, 26 Nov 2013 22:53:55 +0100

quassel (0.9.1-1) unstable; urgency=low

  * New upstream release

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Tue, 05 Nov 2013 17:39:26 +0100

=== debian/control ===
Source: quassel
Section: net
Priority: optional
Maintainer: Thomas Mueller <thomas.mueller@tmit.eu>
Build-Depends: debhelper (>= 9.20120417), libqt4-dev, cmake, libfontconfig1-dev, libfreetype6-dev, libpng-dev, libsm-dev, libice-dev, libxi-dev, libxrandr-dev, libxrender-dev, zlib1g-dev, libssl-dev, libdbus-1-dev, pkg-kde-tools, kdelibs5-dev, libqca2-dev, qt4-dev-tools, libqtwebkit-dev, libindicate-qt-dev, libdbusmenu-qt-dev
Homepage: http://www.quassel-irc.org
Standards-Version: 3.9.5

Package: quassel-core
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, libqt4-sql-sqlite, lsb-base (>= 3.2-14), openssl
Description: distributed IRC client - core component
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides only the core component.

Package: quassel-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, quassel-data (= ${source:Version}), dbus-x11, phonon, gawk
Conflicts: quassel (<< 0.3.1-1), quassel-client-kde4
Replaces: quassel (<< 0.3.1-1)
Description: distributed IRC client - Qt-based client component
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides only the client component.

Package: quassel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt4-sql-sqlite, quassel-data (=${source:Version}), dbus-x11, phonon, gawk
Conflicts: quassel-kde4
Description: distributed IRC client - Qt-based monolithic core+client
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides the monolithic client. It contains both core and
 client and can be used like a traditional IRC client, without requiring an
 external core.

Package: quassel-data
Architecture: all
Depends: ${misc:Depends}
Conflicts: quassel (<< 0.3.1-1), quassel-data-kde4
Replaces: quassel (<< 0.3.1-1)
Description: distributed IRC client - shared data (Qt version)
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides files used by the Qt-based Quassel client
 packages.

Package: quassel-client-kde4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, quassel-data-kde4 (=${source:Version}), dbus-x11, gawk
Conflicts: quassel-client
Description: distributed IRC client - KDE-based client
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides only the client component compiled with KDE4 support.

Package: quassel-kde4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt4-sql-sqlite, quassel-data-kde4 (= ${source:Version}), dbus-x11, gawk
Conflicts: quassel
Description: distributed IRC client - KDE-based monolithic core+client
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides the monolithic client compiled with KDE4 support.
 It contains both core and client and can be used like a traditional IRC
 client, without requiring an external core.

Package: quassel-data-kde4
Architecture: all
Depends: ${misc:Depends}
Conflicts: quassel (<< 0.3.1-1), quassel-data
Replaces: quassel (<< 0.3.1-1)
Description: distributed IRC client - shared data (KDE4 version)
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides files used by the KDE4-based Quassel client
 packages.

=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR_KDE := obj-$(DEB_BUILD_GNU_TYPE)-kde4

%:
	dh $@ --buildsystem=cmake --with=kde

override_dh_auto_configure:
	rm -Rf $(BUILDDIR_KDE)
	mkdir $(BUILDDIR_KDE)

	dh_auto_configure --builddirectory=$(BUILDDIR_KDE) -- -DWANT_MONO=ON -DWITH_KDE=ON -DEMBED_DATA=OFF -DCMAKE_SKIP_RPATH=YES
	dh_auto_configure -- -DWANT_MONO=ON -DWITH_KDE=OFF -DEMBED_DATA=ON -DCMAKE_SKIP_RPATH=YES

override_dh_auto_build:
	dh_auto_build --builddirectory=$(BUILDDIR_KDE)
	dh_auto_build

#override_dh_strip:
#	dh_strip --builddirectory=$(BUILDDIR_KDE) --dbg-package=quassel-kde4-dbg
#	dh_strip --dbg-package=quassel-dbg

override_dh_auto_install:
	dh_auto_install --builddirectory=$(BUILDDIR_KDE) --destdir=debian/kde4-tmp
	rm -r debian/kde4-tmp/usr/share/kde4/apps/quassel/icons/oxygen/AUTHORS
	rm -r debian/kde4-tmp/usr/share/kde4/apps/quassel/icons/oxygen/CONTRIBUTING
	rm -r debian/kde4-tmp/usr/share/kde4/apps/quassel/icons/oxygen/COPYING
	rm -rf debian/kde4-tmp/usr/share/kde4/apps/quassel/icons/oxygen/scalable/
	
	dh_auto_install

override_dh_installinit:
	dh_installinit -r --error-handler=exit --name=quasselcore

override_dh_auto_clean:
	#dh_auto_clean --builddirectory=$(BUILDDIR_KDE)
	dh_auto_clean
	rm -Rf debian/kde4-tmp
	rm -Rf obj-*

## quassel 0.10.1

=== debian/changelog ===
quassel (0.10.1-0ubuntu1) utopic; urgency=medium

  * New upstream bugfix release

 -- Scott Kitterman <scott@kitterman.com>  Thu, 25 Sep 2014 00:19:27 -0400

quassel (0.10.0-0ubuntu2) trusty; urgency=medium

  * Update quasselcore man page to cover all usage options

 -- Scott Kitterman <scott@kitterman.com>  Wed, 09 Apr 2014 16:10:10 -0400

quassel (0.10.0-0ubuntu1) trusty; urgency=medium

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Tue, 25 Mar 2014 23:53:39 +0000

quassel (0.10~rc1-0ubuntu1) trusty; urgency=medium

  * New upstream RC release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Sun, 16 Mar 2014 17:49:07 +0000

quassel (0.10~beta1-0ubuntu1) trusty; urgency=low

  * New upstream beta relase
    - Drop debian/patches/upstream_fix_fullscreen_mode.diff which had been
      cherrypicked from upstream

 -- Scott Kitterman <scott@kitterman.com>  Tue, 18 Feb 2014 23:18:25 -0500

quassel (0.9.2-0ubuntu4) trusty; urgency=medium

  * Cherry pick upstream commit 47a6910aed00018c7230cc2cc90ae8e80fa77dda
    as upstream_fix_fullscreen_mode.diff to fix UI breakage when toggling
    fullscreen mode

 -- Philip Muškovac <yofel@kubuntu.org>  Mon, 23 Dec 2013 01:03:22 +0100

quassel (0.9.2-0ubuntu3) trusty; urgency=low

  * Revert addition of conflict relations between quassel-data and
    quassel-qt4-data, as the packages are usually installed at the same time
    and do not ship common files. (LP: #1257592)

 -- Luke Faraone <lfaraone@ubuntu.com>  Wed, 04 Dec 2013 00:34:49 -0500

quassel (0.9.2-0ubuntu2) trusty; urgency=low

  * Add quasselcore upstart job. Thanks to Michael Marley. (LP: #1244036)
  * Restart quasselcore after upgrades.
  * Make quassel-data and quassel-qt4-data conflict as they ship common files.

 -- Felix Geyer <debfx@ubuntu.com>  Mon, 02 Dec 2013 16:50:58 +0100

quassel (0.9.2-0ubuntu1) trusty; urgency=low

  * New upstream release
    - Includes fix for cross-user data exposure in the core (LP: #1255362)

 -- Scott Kitterman <scott@kitterman.com>  Tue, 26 Nov 2013 19:56:06 -0500
